## seqan2 2.3.2+dfsg2

=== dox/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /dox/CMakeLists.txt
#
# CMakeLists.txt file for dox.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_dox CXX)

find_package (PythonInterp)
if (NOT PYTHONINTERP_FOUND)
    message (STATUS "  Python not found, not building dox as a tests.")
    return ()
endif ()

# find python 2.x
if(NOT(${PYTHON_VERSION_MAJOR} MATCHES "2"))
    set(_PYTHON2_VERSIONS 2.7 2.6 2.5 2.4 2.3 2.2 2.1 2.0)
    unset(_Python_NAMES)
    foreach(_CURRENT_VERSION IN LISTS _PYTHON2_VERSIONS)
        list(APPEND _Python_NAMES "python${_CURRENT_VERSION}")
    endforeach()
    unset(_PYTHON2_VERSIONS)

    find_program(PYTHON2_EXECUTABLE NAMES ${_Python_NAMES})
    if(PYTHON2_EXECUTABLE MATCHES "PYTHON2_EXECUTABLE-NOTFOUND")
        message (STATUS "You need Python 2.x for building dox. (skip the tests)")
        return()
    endif()
    set(PYTHON_EXECUTABLE "${PYTHON2_EXECUTABLE}")
    message (STATUS "Found Python 2.x: ${PYTHON_EXECUTABLE}") 
endif()

# find python 2.x
if(NOT(${PYTHON_VERSION_MAJOR} MATCHES "2"))
    set(_PYTHON2_VERSIONS 2.7 2.6 2.5 2.4 2.3 2.2 2.1 2.0)
    unset(_Python_NAMES)
    foreach(_CURRENT_VERSION IN LISTS _PYTHON2_VERSIONS)
        list(APPEND _Python_NAMES "python${_CURRENT_VERSION}")
    endforeach()
    unset(_PYTHON2_VERSIONS)

    find_program(PYTHON2_EXECUTABLE NAMES ${_Python_NAMES})
    if(PYTHON2_EXECUTABLE MATCHES "PYTHON2_EXECUTABLE-NOTFOUND")
        message (STATUS "You need Python 2.x for building dox. (skip the tests)")
        return()
    endif()
    set(PYTHON_EXECUTABLE "${PYTHON2_EXECUTABLE}")
    message (STATUS "Found Python 2.x: ${PYTHON_EXECUTABLE}")

    # change shell scripts for building dox
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../dox/run.sh.in" run_content)
    file(READ "${CMAKE_CURRENT_SOURCE_DIR}/../dox/dox_only.sh.in" dox_only_content)
    string(REPLACE "python2 ../" "${PYTHON_EXECUTABLE} ../" run_content "${run_content}")
    string(REPLACE "python2 ../" "${PYTHON_EXECUTABLE} ../" dox_only_content "${dox_only_content}")
    file(WRITE "${CMAKE_CURRENT_SOURCE_DIR}/../dox/run.sh" "${run_content}")
    file(WRITE "${CMAKE_CURRENT_SOURCE_DIR}/../dox/dox_only.sh" "${dox_only_content}")
endif()

# Add building the documentation as a test.
add_test (build_dox
  ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../util/bin/dox.py
  -b ${CMAKE_CURRENT_SOURCE_DIR}/..
  -i ${CMAKE_CURRENT_SOURCE_DIR}/../include/seqan
  -i ${CMAKE_CURRENT_SOURCE_DIR}/pages
  --image-dir ${CMAKE_CURRENT_SOURCE_DIR}/images)

if (${SEQAN_BUILD_SYSTEM} MATCHES "SEQAN_RELEASE_LIBRARY") # includes SEQAN_RELEASE_LIBRARY
    add_custom_target (dox ALL
        cd ${CMAKE_CURRENT_SOURCE_DIR} && ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/../util/bin/dox.py
        -b ${CMAKE_CURRENT_SOURCE_DIR}/..
        -i ${CMAKE_CURRENT_SOURCE_DIR}/../include/seqan
        -i ${CMAKE_CURRENT_SOURCE_DIR}/pages
        --image-dir ${CMAKE_CURRENT_SOURCE_DIR}/images
        --out-dir ${CMAKE_BINARY_DIR}/dox/html)

    install (DIRECTORY ${CMAKE_BINARY_DIR}/dox/html
             DESTINATION share/doc/seqan)
endif ()

=== manual/requirements.txt ===
seqansphinx>=0.3.2
sphinx_rtd_theme
sphinxcontrib-bibtex
nose

=== apps/alf/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/alf/CMakeLists.txt
#
# CMakeLists.txt file for ALF.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_alf CXX)
message (STATUS "Configuring apps/alf")

set (SEQAN_APP_VERSION "1.1.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (alf alf.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (alf ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (alf)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install alf in ${PREFIX}/bin directory
install (TARGETS alf
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/alf for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/small.fasta
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (alf)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------
	
# Include executable seqan_tcoffee in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} alf CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")
  set (CPACK_PACKAGE_NAME "alf")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "alf - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (alf "alf")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:alf")

=== apps/bs_tools/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/bs_tools/CMakeLists.txt
#
# CMakeLists.txt file for bs_tools.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_bs_tools CXX)
message (STATUS "Configuring apps/bs_tools")

set (SEQAN_APP_VERSION "0.1.9")

if ((${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD") AND ("$ENV{MODEL}" STREQUAL "Nightly"))
    message (STATUS "bs_tools skipped on FreeBSD because math.h rounding errors.")
    return ()
endif ()

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT Boost_FOUND OR NOT ZLIB_FOUND)
    message (STATUS "  Boost or zlib not found: Not building bs_tools.")
    return ()
endif (NOT Boost_FOUND OR NOT ZLIB_FOUND)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")

# Update the list of file names below if you add source files to your application.
add_executable (bisar bisar.cpp
                    bisar.h
                    bisar_base.h
                    bisar_score.h
                    bisar_score_data.h)

add_executable (casbar casbar.cpp
                    casbar.h
                    casbar_calling.h
                    casbar_realignment.h
                    casbar_consensus_realign.h
                    casbar_score.h
                    casbar_score_data.h
                    casbar_util.h
                    casbar_alphabets.h)

add_executable (four2three four2three.cpp
                    four2three.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (bisar ${SEQAN_LIBRARIES})
target_link_libraries (casbar ${Boost_LIBRARIES} ${SEQAN_LIBRARIES})
target_link_libraries (four2three ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include bs_tools executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES}
        bisar
        casbar
        four2three
        CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (bs_tools)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install bs_tools in ${PREFIX}/bin directory
install (TARGETS bisar casbar four2three
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/bs_tools for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "DEVELOP")
    include("SeqAnConsistentFPFlags")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CONSISTENT_FP_FLAGS}")
endif()

# (weese:) temporarily disabled app test
seqan_add_app_test (bs_tools)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:bs_tools")
  set (CPACK_PACKAGE_NAME "bs_tools")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "bs_tools")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Sabrina Krakau <sabrina.krakau@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (bs_tools "bs_tools")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:bs_tools")

=== apps/dfi/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/dfi/CMakeLists.txt
#
# CMakeLists.txt file for DFI.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_dfi CXX)
message (STATUS "Configuring apps/dfi")

set (SEQAN_APP_VERSION "2.1.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (dfi dfi.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (dfi ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (dfi)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install dfi in ${PREFIX}/bin directory
install (TARGETS dfi
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/dfi for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/fasta1.fa
               example/fasta2.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (dfi)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} dfi CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")
  set (CPACK_PACKAGE_NAME "dfi")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "DFI - Fast String Mining of Multiple Databases under Frequency Constraints")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (dfi "DFI")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:dfi")

=== apps/fiona/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: apps/fiona/CMakeLists.txt
#
# CMakeLists.txt file for fiona.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_fiona CXX)
message (STATUS "Configuring apps/fiona")

set (SEQAN_APP_VERSION "0.2.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (Boost)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# Stop here if we cannot find Boost or OpenMP.
if (NOT Boost_FOUND OR NOT OPENMP_FOUND)
    message (STATUS "  Boost or OpenMP not found, not building fiona.")
    return ()
endif ()

if (NOT CMAKE_SIZEOF_VOID_P EQUAL 8)
    message (STATUS "  Not building fiona on 32bit architectures.")
    return ()
endif()

# all windows compilers are currently broken with Fiona (in different ways)
if (MSVC)
    message (STATUS "  Not building fiona under Visual Studio.")
    return ()
endif()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})
include_directories (SYSTEM ${Boost_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})
#add_definitions("-DQGRAM_LENGTH=5")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (compute_gain compute_gain.cpp)
add_executable (fiona fiona.cpp)
add_executable (fiona_illumina fiona.cpp)

set_target_properties (fiona_illumina PROPERTIES COMPILE_DEFINITIONS "FIONA_ILLUMINA")

# Add dependencies found by find_package (SeqAn).
target_link_libraries (compute_gain ${SEQAN_LIBRARIES})
target_link_libraries (fiona ${SEQAN_LIBRARIES})
target_link_libraries (fiona_illumina ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fiona)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fiona in ${PREFIX}/bin directory
install (TARGETS fiona compute_gain DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fiona for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/reads.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (fiona)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable fiona in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fiona fiona_illumina compute_gain CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")
  set (CPACK_PACKAGE_NAME "fiona")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fiona")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "David Weese <david.weese@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (fiona "fiona")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fiona")

=== apps/fx_tools/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/fx_tools/CMakeLists.txt
#
# CMakeLists.txt file for fx_tools.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_fx_tools CXX)
message (STATUS "Configuring apps/fx_tools")

set (SEQAN_APP_VERSION "0.2.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Setup SeqAn requirements.
include_directories (${SEQAN_INCLUDE_DIRS})
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Computation of coverage and C+G content from genome and mapping.
add_executable (fx_bam_coverage fx_bam_coverage.cpp)
target_link_libraries (fx_bam_coverage ${SEQAN_LIBRARIES})

# Computation of statistics on FASTQ files.
add_executable (fx_fastq_stats fx_fastq_stats.cpp)
target_link_libraries (fx_fastq_stats ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (fx_tools)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install fx_tools in ${PREFIX}/bin directory
install (TARGETS fx_bam_coverage
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/fx_tools for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
#install (FILES example/fasta1.fa
#               example/fasta2.fa
#         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

#seqan_add_app_test (fx_tools)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include executable razers in CTD structure.
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} fx_fastq_stats fx_bam_coverage CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")
  set (CPACK_PACKAGE_NAME "fx_tools")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "fx_tools")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (fx_tools "fx_tools")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:fx_tools")

=== apps/gustaf/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/gustaf/CMakeLists.txt
#
# CMakeLists.txt file for gustaf.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_gustaf CXX)
message (STATUS "Configuring apps/gustaf")

set (SEQAN_APP_VERSION "1.0.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (gustaf gustaf.cpp
                create_stellarmatches_from_file.h
                gustaf_matepairs.h
                msplazer.h
                msplazer_algorithms.h
                msplazer_main.h
                msplazer_out.h
                msplazer_parse_options.h
                stellar_routines.h
)

add_executable (gustaf_mate_joining join_mates.cpp
                create_stellarmatches_from_file.h
                gustaf_matepairs.h
                msplazer.h
                msplazer_algorithms.h
                msplazer_main.h
                msplazer_out.h
                msplazer_parse_options.h
                stellar_routines.h
)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (gustaf ${SEQAN_LIBRARIES})
target_link_libraries (gustaf_mate_joining ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (gustaf)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install gustaf in ${PREFIX}/bin directory
install (TARGETS gustaf gustaf_mate_joining
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/gustaf for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno.fa
               example/adeno_modified.fa
               example/adeno_modified_reads.fa
               example/stellar.gff
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (gustaf)


# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:gustaf")
  set (CPACK_PACKAGE_NAME "gustaf")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Gustaf - Generic multi-split alignment finder")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Kathrin Trappe <kathrin.trappe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Kathrin Trappe <kathrin.trappe@fu-berlin.de>")
  set (CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README.rst")

  seqan_configure_cpack_app (gustaf "gustaf")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:gustaf")

=== apps/insegt/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/insegt/CMakeLists.txt
#
# CMakeLists.txt file for insegt.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_insegt CXX)
message (STATUS "Configuring apps/insegt")

set (SEQAN_APP_VERSION "1.1.9")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Update the list of file names below if you add source files to your application.
add_executable (insegt
                insegt.cpp
                base.h
                create_gff.h
                fusion.h
                overlap_module.h)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (insegt ${SEQAN_LIBRARIES})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (insegt)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install insegt in ${PREFIX}/bin directory
install (TARGETS insegt
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/insegt for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/annoOutput.gff
               example/annotations.gff
               example/readOutput.gff
               example/tupleOutput.gff
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

# Add app tests if Python interpreter could be found.
if(PYTHONINTERP_FOUND)
  add_test(NAME app_test_insegt COMMAND ${PYTHON_EXECUTABLE}
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run_tests.py ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR})
endif(PYTHONINTERP_FOUND)

seqan_add_app_test (insegt)

# ---------------------------------------------------------------------------- 
# Setup Common Tool Description for Generic Workflow Nodes 
# ---------------------------------------------------------------------------- 
 
# Include executable razers in CTD structure. 
set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} insegt CACHE INTERNAL "") 

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")
  set (CPACK_PACKAGE_NAME "insegt")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "insegt - Alignment Free Sequence Comparison")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (insegt "insegt")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:insegt")

=== apps/mason2/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /mason2/CMakeLists.txt
#
# CMakeLists.txt file for mason2.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_mason2 CXX)
message (STATUS "Configuring apps/mason2")

set (SEQAN_APP_VERSION "2.0.8")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (OpenMP)
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

if (NOT ZLIB_FOUND)
  message (STATUS "  ZLIB not found: MASON2 will not be built.")
  return ()
endif (NOT ZLIB_FOUND)

# Enable C++11 in GCC and/or CLANG.
#if (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)
#    add_definitions ("-std=c++0x")
#endif (CMAKE_COMPILER_IS_GNUCXX OR COMPILER_IS_CLANG)

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# We define a library for the reusable parts of Mason.
add_library (mason_sim
             external_split_merge.h
             external_split_merge.cpp
             fragment_generation.h
             genomic_variants.h
             genomic_variants.cpp
             individual_genome.h
             mason_options.cpp
             mason_options.h
             mason_types.h
             methylation_levels.cpp
             methylation_levels.h
             omp_wrapper.h
             sequencing.h
             simulate_454.cpp
             simulate_base.cpp
             simulate_genome.cpp
             simulate_genome.h
             simulate_illumina.cpp
             simulate_sanger.cpp
             variation_size_tsv.h
             vcf_materialization.cpp
             vcf_materialization.h)
target_link_libraries (mason_sim ${SEQAN_LIBRARIES})


# Simulate random genomes.
add_executable (mason_genome mason_genome.cpp)

# Simulate methylation levels for gnome.
add_executable (mason_methylation mason_methylation.cpp)

# Simulate sequencing of fragments.
add_executable (mason_frag_sequencing mason_frag_sequencing.cpp)

# Simulation of structural variants into FASTA sequences.
add_executable (mason_variator mason_variator.cpp)

# The materializer reads in FASTA and VCF and writes out FASTA.
add_executable (mason_materializer mason_materializer.cpp)

# The end-to-end read simulator includes materialization and fragment sampling.
add_executable (mason_simulator mason_simulator.cpp)

# Simulation splicing given a reference, GFF/GTF file, and possibly VCF for variants.
add_executable (mason_splicing mason_splicing.cpp)

# Tests for some of the library functionality.
add_executable (mason_tests mason_tests.cpp)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (mason_frag_sequencing ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_genome ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_materializer ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_methylation ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_simulator ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_splicing ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_tests ${SEQAN_LIBRARIES} mason_sim)
target_link_libraries (mason_variator ${SEQAN_LIBRARIES} mason_sim)

# ----------------------------------------------------------------------------
# Setup Common Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Include mason executables in CTD structure.
set (SEQAN_CTD_EXECUTABLES
    ${SEQAN_CTD_EXECUTABLES}
    mason_genome
    mason_frag_sequencing
    mason_variator
    mason_materializer
    mason_simulator
    CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (mason2)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install Mason binaries in ${PREFIX}/bin directory
install (TARGETS mason_frag_sequencing
                 mason_genome
                 mason_materializer
                 mason_methylation
                 mason_simulator
                 mason_splicing
                 mason_variator
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/mason2 for SeqAn release builds.
install (FILES LICENSE
               README
               README.mason_frag_sequencing
               README.mason_genome
               README.mason_materializer
               README.mason_methylation
               README.mason_simulator
               README.mason_splicing
               README.mason_variator
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})
install (FILES example/adeno_virus.fa
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (mason2)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")
  set (CPACK_PACKAGE_NAME "mason2")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "Versatile package for the simulation of nucleic sequence.")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")

  seqan_configure_cpack_app (mason2 "mason2")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:mason2")

=== apps/ngs_roi/CMakeLists.txt ===
# ===========================================================================
#                  NGS: Regions of Interest Analysis
# ===========================================================================
# File: /sandbox/jagla/apps/ngs_roi/CMakeLists.txt
#
# CMakeLists.txt file for ngs_roi.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_ngs_roi CXX)
message (STATUS "Configuring apps/ngs_roi")

set (SEQAN_APP_VERSION "0.2.11")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.

if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (ZLIB)
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your application.
add_executable (roi_plot_thumbnails roi_plot_thumbnails.cpp png_canvas.h)
target_link_libraries (roi_plot_thumbnails ${SEQAN_LIBRARIES})

# bam2roi converts BAM file into ROI files.
add_executable (bam2roi bam2roi.cpp roi_builder.h roi_builder.cpp record_ext.h)
target_link_libraries (bam2roi ${SEQAN_LIBRARIES})

# roi_feature_projection allows the projection of ROIs to features (BED/GFF
# intervals or GFF exons).
add_executable (roi_feature_projection
                roi_feature_projection.cpp
                project_spliced.cpp
                project_spliced.h
                project_interval.cpp
                project_interval.h)
target_link_libraries (roi_feature_projection ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (ngs_roi)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install binaries into ${PREFIX}/bin directory.
install (TARGETS bam2roi
                 roi_feature_projection
                 roi_plot_thumbnails
         DESTINATION bin)

# Install helper scripts into ${PREFIX}/bin directory.
install (FILES # Scripts for sorting.
                 tool_shed/bed_sort.sh
                 tool_shed/gff_sort.sh
                 tool_shed/roi_sort.sh
                 # PDF plot script helper.
                 tool_shed/roi_plot_9.sh
                 tool_shed/plot.awk
                 tool_shed/ps2pswLinks.gawk
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/ngs_roi for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# Example files.
install (FILES example/dmel.bed
               example/dmel.gtf
               example/example.bam
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/example)

# R package for Linux and Mac.
install (FILES R/ngsroi_0.1.tar.gz
               R/ngsroi_0.1.zip
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC}/R)

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (ngs_roi)

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:ngs_roi")
  set (CPACK_PACKAGE_NAME "ngs_roi")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "ngs_roi")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Bernd Jagla <bernd.jagla@pasteur.fr>")
  set (CPACK_PACKAGE_VENDOR "Bernd Jagla <bernd.jagla@pasteur.fr>")

  seqan_configure_cpack_app (ngs_roi "ngs_roi")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:ngs_roi")

=== apps/pair_align/CMakeLists.txt ===
# ===========================================================================
#                  SeqAn - The Library for Sequence Analysis
# ===========================================================================
# File: /apps/pair_align/CMakeLists.txt
#
# CMakeLists.txt file for pair_align.
# ===========================================================================

cmake_minimum_required (VERSION 3.0.0)
project (seqan_apps_pair_align CXX)
message (STATUS "Configuring apps/pair_align")

set (SEQAN_APP_VERSION "1.3.7")

# ----------------------------------------------------------------------------
# Dependencies
# ----------------------------------------------------------------------------

# Search SeqAn and select dependencies.
if (NOT "${SEQAN_BUILD_SYSTEM}" STREQUAL "DEVELOP")
    find_package (SeqAn CONFIG REQUIRED)
endif ()

# ----------------------------------------------------------------------------
# Build Setup
# ----------------------------------------------------------------------------

# Add include directories.
include_directories (${SEQAN_INCLUDE_DIRS})

# Add definitions set by find_package (SeqAn).
add_definitions (${SEQAN_DEFINITIONS})

# Add definitions set by the build system.
add_definitions (-DSEQAN_APP_VERSION="${SEQAN_APP_VERSION}")
add_definitions (-DSEQAN_REVISION="${SEQAN_REVISION}")
add_definitions (-DSEQAN_DATE="${SEQAN_DATE}")

# Add CXX flags found by find_package (SeqAn).
set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${SEQAN_CXX_FLAGS}")

# Update the list of file names below if you add source files to your application.
add_executable (pair_align pair_align.cpp)

#Before linking create static library for pair_align
# Include lib folder to build the static library pair_align_lib.
add_subdirectory(lib)

# Add dependencies found by find_package (SeqAn).
target_link_libraries (pair_align pair_align_lib ${SEQAN_LIBRARIES})

# ----------------------------------------------------------------------------
# Installation
# ----------------------------------------------------------------------------

# Set variables for installing, depending on the selected build type.
if (NOT SEQAN_PREFIX_SHARE_DOC)
  seqan_setup_install_vars (pair_align)
endif (NOT SEQAN_PREFIX_SHARE_DOC)

# Install pair_align in ${PREFIX}/bin directory
install (TARGETS pair_align
         DESTINATION bin)

# Install non-binary files for the package to "." for app builds and
# ${PREFIX}/share/doc/pair_align for SeqAn release builds.
install (FILES LICENSE
               README
         DESTINATION ${SEQAN_PREFIX_SHARE_DOC})

# ----------------------------------------------------------------------------
# App Test
# ----------------------------------------------------------------------------

seqan_add_app_test (pair_align)

# ----------------------------------------------------------------------------
# Setup Command Tool Description for Generic Workflow Nodes
# ----------------------------------------------------------------------------

# Currently, pair_align uses a lot of memory to compile so we do not add it
# to the list of programs to build for workflow engines.

#Include executable pair_align in CTD structure.
#set (SEQAN_CTD_EXECUTABLES ${SEQAN_CTD_EXECUTABLES} pair_align CACHE INTERNAL "")

# ----------------------------------------------------------------------------
# CPack Install
# ----------------------------------------------------------------------------

if (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")
  set (CPACK_PACKAGE_NAME "pair_align")
  set (CPACK_PACKAGE_DESCRIPTION_SUMMARY "pair_align - Pairwise Sequence Alignment")
  set (CPACK_DEBIAN_PACKAGE_MAINTAINER "Manuel Holtgrewe <manuel.holtgrewe@fu-berlin.de>")
  set (CPACK_PACKAGE_VENDOR "SeqAn Team, FU Berlin")

  seqan_configure_cpack_app (pair_align "pair_align")
endif (SEQAN_BUILD_SYSTEM STREQUAL "APP:pair_align")

=== debian/changelog ===
seqan2 (2.3.2+dfsg2-4ubuntu2) bionic; urgency=medium

  * Add ppc64el to the list of low-memory architectures

 -- Steve Langasek <steve.langasek@ubuntu.com>  Tue, 03 Apr 2018 21:55:05 -0700

seqan2 (2.3.2+dfsg2-4ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add amd64 and arm64 to the list of low-memory architectures
    - Enable build on armhf

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 04 Jan 2018 08:40:33 -0800

seqan2 (2.3.2+dfsg2-4) unstable; urgency=medium

  * Work around missing dir in indep-only builds
    Closes: #882169
  * d/rules: drop --parallel which is redundant for debhelper 10
  * Do not generate manpages in arch indep builds (as done in
    experimental branch)

 -- Andreas Tille <tille@debian.org>  Wed, 06 Dec 2017 11:11:59 +0100

seqan2 (2.3.2+dfsg2-3ubuntu1) bionic; urgency=low

  * Merge from Debian unstable.  Remaining changes:
    - Add amd64 and arm64 to the list of low-memory architectures
    - Enable build on armhf

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 26 Oct 2017 20:55:43 -0700

seqan2 (2.3.2+dfsg2-3) unstable; urgency=medium

  * Patch for mips64el from bunk@debian.org (Closes: #878933)
  * Cleaned up per-arch settings in debian/rules
  * Disable parallel building on sh4

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Tue, 24 Oct 2017 04:56:12 -0700

seqan2 (2.3.2+dfsg2-2) unstable; urgency=medium

  * As per upstream, disable async-io for many platforms
  * Remove jinja2, python-nose, and dh-linktree dependencies as we are not yet
    building the docs
  * Switch to GitHub releases for HTTPS protection

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Oct 2017 10:48:00 -0700

seqan2 (2.3.2+dfsg2-1) unstable; urgency=medium

  * Still not enough memory for seqan-apps on amrhf, disabling
  * seqan-apps: run tests post build, everywhere

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Fri, 13 Oct 2017 05:01:16 -0700

seqan2 (2.3.2+dfsg-2) unstable; urgency=medium

  * Re-enable armhf, h/t Ubuntu
  * Disabling armel again due to lack of memory on buildd. (Closes: #877349)

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 07 Oct 2017 10:28:57 -0700

seqan2 (2.3.2+dfsg-1) unstable; urgency=medium

  * New upstream release.
  * Re-enable armel, now that upstream bug fixed in
    https://gcc.gnu.org/bugzilla/show_bug.cgi?id=64735
  * removed debian/patches/skip-SEQAN_PKGCFG_CFLAGS, incorporated upstream

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Thu, 28 Sep 2017 09:15:34 -0700

=== debian/control ===
Source: seqan2
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>,
           Michael R. Crusoe <michael.crusoe@gmail.com>,
           Kevin Murray <spam@kdmurray.id.au>
Section: science
Priority: optional
Build-Depends: debhelper (>= 10),
               python
Build-Depends-Arch: cmake,
                    zlib1g-dev,
                    libbz2-dev,
                    libbam-dev,
                    libboost-dev,
                    help2man,
#Build-Depends-Indep: dh-exec
#dh-linktree,
#python-nose,
#python-jinja2,
#default-jdk,
#python-sphinx,
#python-sphinx-rtd-theme,
Standards-Version: 4.1.1
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/seqan2.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/seqan2.git
Homepage: http://www.seqan.de/

Package: seqan-apps
Architecture: any-amd64 arm64 armhf any-i386 mips64el powerpc ppc64el s390x alpha hppa m68k powerpcspe ppc64 sh4 sparc64 x32
# Skipping armel as per Adrian Bunk <bunk@debian.org> https://bugs.debian.org/877349
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: C++ library for the analysis of biological sequences
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance. This package contains the applications dfi, pair_align,
 micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.

Package: libseqan2-dev
Architecture: all
Section: libdevel
Depends: ${misc:Depends}
Conflicts: seqan-dev
Multi-Arch: foreign
Description: C++ library for the analysis of biological sequences (development)
 SeqAn is a C++ template library of efficient algorithms and data
 structures for the analysis of sequences with the focus on
 biological data. This library applies a unique generic design that
 guarantees high performance, generality, extensibility, and
 integration with other libraries. SeqAn is easy to use and
 simplifies the development of new software tools with a minimal loss
 of performance.
 .
 This package contains the developer files.

#Package: seqan2-doc
#Architecture: all
#Section: doc
#Depends: ${misc:Depends},
#         libjs-bootstrap,
#         libjs-prettify,
#         libjs-jquery
#Description: C++ library for the analysis of biological sequences (documentation)
# SeqAn is a C++ template library of efficient algorithms and data
# structures for the analysis of sequences with the focus on
# biological data. This library applies a unique generic design that
# guarantees high performance, generality, extensibility, and
# integration with other libraries. SeqAn is easy to use and
# simplifies the development of new software tools with a minimal loss
# of performance. This package contains the applications dfi, pair_align,
# micro_razers, seqan_tcoffee, seqcons, razers and tree_recon.
# .
# This package contains the documentation and examples.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

export DH_BUILD_MAINT_OPTIONS = hardening=+all
include /usr/share/dpkg/pkg-info.mk
export HOME=$(shell echo $$PWD"/fakehome")

# import hardening, adding CPPFLAGS to CFLAGS, in case dh doesn't
# See https://wiki.debian.org/Hardening#Notes_for_packages_using_CMake
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

# Droping -fstack-protector flag helps **drastically** reducing memory consumption when building the package!!!!
# export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS | sed 's/-fstack-protector *//')  ## don't do this, it simply triggers #759978
# export DEB_BUILD_MAINT_OPTIONS = hardening=-stackprotector
# alternatively: export DEB_CXXFLAGS_STRIP='-fstack-protector'

DEB_HOST_ARCH       ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)

DEB_BUILD_ARCH          ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifneq (,$(filter mips mipsel kfreebsd% hurd%,$(DEB_BUILD_ARCH)))
    CXXFLAGS+=-O1
    CFLAGS+=-01
else
    CXXFLAGS+=-O3
    CFLAGS+=-O3
endif

ifneq (,$(filter mips mipsel mips64el,$(DEB_BUILD_ARCH)))
    export CXXFLAGS+=-mxgot
endif
# Disable parallel building on some build archs to save memory
ifneq (,$(filter amd64 arm64 armhf mips kfreebsd% ppc64el sh4,$(DEB_BUILD_ARCH)))
    $(info $$DEB_BUILD_OPTIONS was [${DEB_BUILD_OPTIONS}])
    TDBO := $(DEB_BUILD_OPTIONS)
    export DEB_BUILD_OPTIONS=parallel=1,$(filter $(TDBO), parallel)
endif
$(info $$DEB_BUILD_OPTIONS is [${DEB_BUILD_OPTIONS}])

ifneq (,$(filter mips64el ppc64el s390x alpha hppa powerpc ppc64 sparc64,$(DEB_HOST_ARCH)))
# Disable async io on certain target archs, as per upstream
# https://github.com/seqan/seqan/issues/1861#issuecomment-336484553
CXXFLAGS+="-DSEQAN_ASYNC_IO=0"
endif

pkgapps=seqan-apps
pkgdev=libseqan2-dev

%:
	dh $@

override_dh_auto_configure-arch:
	#	dh_auto_configure -- -DSEQAN_BUILD_SYSTEM=SEQAN_RELEASE_APPS -DSEQAN_STATIC_APPS=False  # skip the tests for now
	dh_auto_configure -- -DSEQAN_BUILD_SYSTEM=DEVELOP \
		-DSEQAN_STATIC_APPS=False -DSEQAN_NO_DOX=1 \
		-DSEQAN_DISABLE_VERSION_CHECK=YES

override_dh_auto_configure-indep: ;

override_dh_auto_build-arch:
	dh_auto_build --arch
	#cd obj-$(DEB_BUILD_GNU_TYPE); make dox # This does nothing and no *.html files will be created at all
	# This ends up in:
	# Could not import extension sphinxcontrib.bibtex (exception: No module named sphinxcontrib.bibtex)
	# Seems there is no sphinx module bibtex - thus deactivating creation of html manual
	# cd manual && make html

override_dh_auto_build-indep:
	sed -e "s#@CMAKE_INSTALL_PREFIX@#/usr#g" \
	    -e "s/@SEQAN_VERSION_STRING@/$(DEB_VERSION_UPSTREAM_REVISION)/g" \
	    -e "s/@CMAKE_PROJECT_NAME@/seqan/g" \
	    util/pkgconfig/seqan.pc.in > seqan-2.pc

override_dh_install:
	dh_install
	# Delete additional LICENSE files
	find $(CURDIR)/debian/$(pkgapps) -type f -name LICENSE -delete || /bin/true
	if [ -d $(CURDIR)/debian/$(pkgdev) ] ; then \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name LICENSE -delete ; \
	    find $(CURDIR)/debian/$(pkgdev) -type f -name "*.pyc" -delete ; \
	fi

override_dh_auto_clean:
	dh_auto_clean
	find . -type f -name "*.pyc" -delete
	if [ -d orig ] ; then \
	  for header in `find orig -name "*generated_forwards.h"` ; do \
	    mv $${header} `echo $$header | sed 's?orig/??'` ; \
	  done ; \
	fi
	rm -rf orig seqan-2.pc

override_dh_installman-arch:
	dh_link -a
	$(CURDIR)/debian/generate_manpages
	#for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin` ; do \
	#    if [ -x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ] ; then \
	#        ln -s ../lib/seqan/bin/`basename $${bin}` $(CURDIR)/debian/$(pkgapps)/usr/bin/`basename $${bin}` ; \
	#    fi ; \
	#    if echo $${bin} | grep -q '\.sh$$' ; then \
	#        ln -s ../lib/seqan/bin/$${bin} $(CURDIR)/debian/$(pkgapps)/usr/bin/`basename $${bin} .sh` ; \
	#    fi ; \
	#done
	# we generate only those manpages where binaries are linked to /usr/bin
	dh_installman -a

override_dh_link-arch:
	dh_link
	# Some binaries (eg. splazer) are not built in 32-bit architectures so
	# remove their (broken) symlinks.
	if [ -d $(CURDIR)/debian/$(pkgapps)/usr/bin ] ; then \
	    find $(CURDIR)/debian/$(pkgapps)/usr/bin -type l -xtype l -delete ; \
	fi

override_dh_fixperms-indep:
	dh_fixperms
	for bin in `ls $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/*.sh` ; do \
	    chmod +x $(CURDIR)/debian/$(pkgapps)/usr/lib/seqan/bin/`basename $${bin}` ; \
	done
	find $(CURDIR)/debian/$(pkgdev)/usr/share/cmake -type f -exec chmod -x {} \;

override_dh_auto_test:
# enforce tests on some architectures
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 i386 kfreebsd-amd64 m68k x32))
	dh_auto_test
else
	dh_auto_test || /bin/true
endif
